﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace rejtveny
{
    class Hely
    {
        public int X { get; set; }
        public int Y { get; set; }
        public int Num { get; set; }
        public Hely(int x, int y, int num)
        {
            X = x;
            Y = y;
            Num = num;
        }
    }

    class Tábla
    {
        public string Név { get; set; }
        public int[,] T { get; set; }
        public List<Hely> Torony { get; set; }
        public List<Hely> Hajó { get; set; }
        public Tábla(string név, string[] adat)
        {
            Név = név;
            T = new int[10, 10];
            Torony = new List<Hely>();
            Hajó = new List<Hely>();
            for (int i = 0; i < 10; i++)
            {
                for (int j = 0; j < 10; j++)
                {
                    T[i, j] = Convert.ToInt32(adat[i].Split(' ')[j]);
                    if (T[i, j] > 0 && T[i, j] < 10)
                    {
                        Torony.Add(new Hely(i, j, T[i, j]));
                    }
                    else if (T[i, j] == 11)
                    {
                        Hajó.Add(new Hely(i, j, 11));
                    }
                }
            }
        }
        
        //3. feladathoz
        public bool EHeti(Tábla Feladv)
        {
            bool azonos = false;
            if (Feladv.Torony.Count == Torony.Count)
            {
                int i = 0;
                while (i < Torony.Count && Feladv.Torony[i].X == Torony[i].X && Feladv.Torony[i].Y == Torony[i].Y && Feladv.Torony[i].Num == Torony[i].Num)
                {
                    i++;
                }
                if (i == Feladv.Torony.Count)
                {
                    azonos = true;
                }
            }
            return azonos;
        }

        public bool Távtartó()
        {
            bool jó = true;
            int i = 0;
            while (i < Torony.Count && jó)
            {
                int tólX = Math.Max(0, Torony[i].X - 1);
                int igX = Math.Min(9, Torony[i].X + 1);
                int tólY = Math.Max(0, Torony[i].Y - 1);
                int igY = Math.Min(9, Torony[i].Y + 1);
                for (int s = tólX; s <= igX; s++)
                {
                    for (int o = tólY; o <= igY; o++)
                    {
                        if (!(s == Torony[i].X && o == Torony[i].Y) && T[s, o] != 0)
                        {
                            jó = false;
                        }
                    }
                }
                i++;
            }
            i = 0;
            while (i < Hajó.Count && jó)
            {
                int tólX = Math.Max(0, Hajó[i].X - 1);
                int igX = Math.Min(9, Hajó[i].X + 1);
                int tólY = Math.Max(0, Hajó[i].Y - 1);
                int igY = Math.Min(9, Hajó[i].Y + 1);
                for (int s = tólX; s <= igX; s++)
                {
                    for (int o = tólY; o <= igY; o++)
                    {
                        if (!(s == Hajó[i].X && o == Hajó[i].Y) && T[s, o] != 0)
                        {
                            jó = false;
                        }
                    }
                }
                i++;
            }

            return jó;
        }

        public bool HelyesDb()
        {
            bool jó = true;
            int i = 0;
            while (i< Torony.Count && jó)
            {
                int db = 0;
                for (int s = 0; s < 10; s++)
                {
                    if ( T[s,Torony[i].Y] == 11)
                    {
                        db++;
                    }
                }
                for (int o = 0; o < 10; o++)
                {
                    if (T[Torony[i].X, o] == 11)
                    {
                        db++;
                    }
                }
                if (db != Torony[i].Num)
                {
                    jó = false;
                }
                i++;
            }
            return jó;
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            #region 1. feladat - egy torony adata
            Console.Write("1. feladat: Adja meg egy torony adatait szóközzel elválasztva (1<=sor, oszlop<=10; 1<=torony<=9): ");
            string[] adat = Console.ReadLine().Split(' ');
            Hely egytorony = new Hely(int.Parse(adat[0]), int.Parse(adat[1]), int.Parse(adat[2]));
            if (egytorony.Num > 3)
            {
                Console.WriteLine("Nehéz torony");
            }
            #endregion
            #region 2. feladat - egy torony körül a tiltott mezők
            Console.WriteLine("2. feladat tiltott mezők");
            int tólX = Math.Max(1, egytorony.X - 1);
            int igX = Math.Min(10, egytorony.X + 1);
            int tólY = Math.Max(1, egytorony.Y - 1);
            int igY = Math.Min(10, egytorony.Y + 1);
            for (int i = tólX; i <= igX; i++)
            {
                for (int j = tólY; j <= igY; j++)
                {
                    if (!(i == egytorony.X && j == egytorony.Y))
                    {
                        Console.WriteLine("{0},{1}", i, j);
                    }
                }
            }
            #endregion
            #region 3. feladat - beolvasás, ehetiek szűrés
            Console.WriteLine("3. feladat: Nem eheti megoldást küldtek be:");
            StreamReader sr = new StreamReader("feladvany.txt");
            string[] adatok = new string[10];
            for (int i = 0; i < 10; i++)
            {
                adatok[i] = sr.ReadLine();
            }
            Tábla rejtény = new Tábla("rejvény", adatok);
            sr.Close();
            sr = new StreamReader("megoldas.txt");
            int db = int.Parse(sr.ReadLine());
            List<Tábla> megoldás = new List<Tábla>();
            for (int m = 0; m < db; m++)
            {
                string név = sr.ReadLine();
                for (int i = 0; i < 10; i++)
                {
                    adatok[i] = sr.ReadLine();
                }
                Tábla mo = new Tábla(név, adatok);
                if (mo.EHeti(rejtény))
                {
                    megoldás.Add(mo);
                }
                else
                {
                    Console.WriteLine(mo.Név);
                }
            }
            #endregion
            #region 4. feladat - hibás hajószám szűrése
            Console.WriteLine("4. feladat");
            List<Tábla> Hajó12 = new List<Tábla>();
            int rossz = 0;
            foreach (Tábla Mo in megoldás)
            {
                if (Mo.Hajó.Count == 12)
                {
                    Hajó12.Add(Mo);
                }
                else
                {
                    rossz++;
                }
            }
            Console.WriteLine("{0} darab megoldás kiesett, nem megfelelő számú hajó miatt", rossz);
            #endregion
            #region 5. feladat - szomszédos szabály megsértésének szűrése
            Console.WriteLine("5. feladat:");
            List<Tábla> JóSzomszéd = new List<Tábla>();
            rossz = 0;
            foreach (Tábla Mo in Hajó12)
            {
                if (Mo.Távtartó())
                {
                    JóSzomszéd.Add(Mo);
                }
                else
                {
                    rossz++;
                }
            }
            Console.WriteLine("{0} darab megoldás kiesett, a szomszédsági szabály megsértése miatt", rossz);
            #endregion
            #region 6. feladat - helyes megoldók megadása
            int helyes = 0;
            List<string> nyertes = new List<string>();
            foreach (Tábla Mo in JóSzomszéd)
            {
                if (Mo.HelyesDb())
                {
                    helyes++;
                    nyertes.Add(Mo.Név);
                }
            }
            Console.WriteLine("6. feladat: Helyes megoldást beküldők száma {0}",helyes);
            foreach (string nyert in nyertes)
            {
                Console.WriteLine(nyert);    
            }
            #endregion
            Console.ReadKey();

        }
    }
}
